---
title: Updating add-ons for Firefox 6
slug: Mozilla/Firefox/Releases/6/Updating_add-ons
tags:
  - API
  - Add-ons
  - Firefox
---
<div>{{FirefoxSidebar}}</div><p>This article provides an overview of the changes you may need to make to your add-ons in order for them to work properly in Firefox 6. You can find a complete list of developer-related changes in Firefox 6 in <a href="/en/Firefox_6_for_developers" title="en/Firefox 6 for developers">Firefox 6 for developers</a>.</p>

<h2 id="Do_you_need_to_do_anything_at_all">Do you need to do anything at all?</h2>

<p>If your add-on is distributed on <a class="external" href="http://addons.mozilla.org" title="http://addons.mozilla.org/">addons.mozilla.org</a> (AMO), it's been checked by an automated compatibility verification tool. Add-ons that don't use APIs that changed in Firefox 6, and have no binary components (which <a href="/En/Developer_Guide/Interface_Compatibility#Binary_Interfaces" title="En/Developer Guide/Interface Compatibility#Binary Interfaces">need to be recompiled for every major Firefox release</a>), have automatically been updated on AMO to indicate that they work in Firefox 6.</p>

<p>So you should start by visiting AMO and looking to see if your add-on needs any work done at all.</p>

<div class="note"><strong>Note:</strong> You should still test your add-on on Firefox 6, even if it's been automatically upgraded. There are edge cases that may not be automatically detected.</div>

<p>Once you've confirmed that you need to make changes, come on back to this page and read on.</p>

<h2 id="UI_changes">UI changes</h2>

<p>The addition of the new Web Developer sub-menu in the Tools menu means that overlays that rely on the items that have been moved there will work differently than they used to. Your overlays will continue to work, but your items will not wind up where you expect them to. You should update your overlays to ensure that menu items go where you intend them to go.</p>

<p>Similarly, the order of menu items in the History and Bookmarks menus may also affect your add-on's overlays.</p>

<h2 id="Binary_component_compatibility">Binary component compatibility</h2>

<p>A bug in Firefox 5 meant that binary components were not properly being rejected if they were built for a different version of Gecko. This is fixed in Firefox 6; if your add-on's binary components don't load, check to be sure you've rebuilt them against the Gecko 6 SDK.</p>

<h2 id="Preferences">Preferences</h2>

<p>The <code>app.update.timer</code> preference was removed; you need to use the <code>app.update.timerMinimumDelay</code> preference instead.</p>

<p>Also, site-specific privacy preferences have been added. This will only impact add-ons that expect privacy related preferences (privacy, remember passwords, and so forth) being in the main preference window.</p>

<h2 id="DOM_changes">DOM changes</h2>

<p>The {{ domxref("window.top") }} property is now read only. This will affect your add-on if you have an undeclared variable named <code>top</code> in a chrome script.</p>

<h2 id="URL_handling">URL handling</h2>

<p><code>javascript:</code> and <code>data:</code> URLs entered into the location bar no longer inherit the principal of the currently loaded page. This probably won't affect many add-ons but if you run code that uses these URLs you may want to double check that everything is working as expected.</p>

<p>{{ Bug("658949") }} changed how the hash (#) symbol is treated in data URIs which may break CSS stylesheets which contain such symbol if it is not escaped.</p>

<h2 id="Interfaces">Interfaces</h2>

<p>A few interfaces that were deprecated or implementation details <a href="/en/Firefox_6_for_developers#Removed_interfaces" title="en/Firefox 6 for developers#Removed interfaces">have been removed</a>. If you rely on any of them, you need to revise your code.</p>
